Loading...
Searching...
No Matches
casacore::ISMBase Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <ISMBase.h>`

## Public Member Functions

| ISMBase (uInt bucketSize=0, Bool checkBucketSize=True, uInt cacheSize=1)
| Create an incremental storage manager without a name.
| ISMBase (const String &dataManagerName, uInt bucketSize, Bool checkBucketSize, uInt cacheSize)
| Create an incremental storage manager with the given name.
| ISMBase (const String &aDataManName, const Record &spec)
| Create an incremental storage manager with the given name.
| ~ISMBase ()
ISMBase & | operator= (const ISMBase &that)=delete
| Assignment cannot be used.
virtual DataManager * | clone () const
| Clone this object.
virtual String | dataManagerType () const
| Get the type name of the data manager (i.e.
virtual String | dataManagerName () const
| Get the name given to the storage manager (in the constructor).
virtual Record | dataManagerSpec () const
| Record a record containing data manager specifications.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties.
uInt | version () const
| Get the version of the class.
void | setCacheSize (uInt cacheSize, Bool canExceedNrBuckets)
| Set the cache size (in buckets).
uInt | cacheSize () const
| Get the current cache size (in buckets).
void | clearCache ()
| Clear the cache used by this storage manager.
virtual void | showCacheStatistics (ostream &os) const
| Show the statistics of all caches used.
void | showIndexStatistics (ostream &os)
| Show the index statistics.
void | showBucketLayout (ostream &os)
| Show the layout of the buckets.
uInt | bucketSize () const
| Get the bucket size (in bytes).
uInt | uIntSize () const
| Get the size of a uInt in external format (can be canonical or local).
uInt | rownrSize () const
| Get the size of a rownr in external format (can be canonical or local).
ISMBucket * | getBucket (rownr_t rownr, rownr_t &bucketStartRow, rownr_t &bucketNrrow)
| Get the bucket containing the given row.
ISMBucket * | nextBucket (uInt &cursor, rownr_t &bucketStartRow, rownr_t &bucketNrrow)
| Get the next bucket.
char * | tempBuffer () const
| Get access to the temporary buffer.
uInt | uniqueNr ()
| Get a unique column number for the column (it is only unique for this storage manager).
rownr_t | nrow () const
| Get the number of rows in this storage manager.
virtual Bool | canAddRow () const
| Can the storage manager add rows?
virtual Bool | canRemoveRow () const
| Can the storage manager delete rows?
virtual Bool | canAddColumn () const
| Can the storage manager add columns?
virtual Bool | canRemoveColumn () const
| Can the storage manager delete columns?
ISMColumn & | getColumn (uInt colnr)
| Get access to the given column.
void | addBucket (rownr_t rownr, ISMBucket *bucket)
| Add a bucket to the storage manager (i.e.
void | setBucketDirty ()
| Make the current bucket in the cache dirty (i.e.
StManArrayFile * | openArrayFile (ByteIO::OpenOption opt)
| Open (if needed) the file for indirect arrays with the given mode.
Bool | checkBucketLayout (uInt &offendingCursor, rownr_t &offendingBucketStartRow, uInt &offendingBucketNrow, uInt &offendingBucketNr, uInt &offendingCol, uInt &ffendingIndex, rownr_t &offendingRow, rownr_t &offendingPrevRow)
| Check that there are no repeated rowIds in the buckets comprising this ISM.
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Bool | isStorageManager () const
| Is the data manager a storage manager?
virtual Bool | canReallocateColumns () const
| Tell if the data manager wants to reallocate the data manager column objects.
virtual DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.

## Static Public Member Functions

static DataManager * | makeObject (const String &dataManagerType, const Record &spec)
| Make the object from the type name string.
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.

## Private Member Functions

| ISMBase (const ISMBase &that)
| Copy constructor (only meant for clone function).
void | recreate ()
| (Re)create the index, file, and cache object.
virtual Bool | hasMultiFileSupport () const
| The data manager supports use of MultiFile.
virtual Bool | flush (AipsIO &, Bool fsync)
| Flush and optionally fsync the data.
virtual void | create64 (rownr_t nrrow)
| Let the storage manager create files as needed for a new table.
virtual rownr_t | open64 (rownr_t nrrow, AipsIO &)
| Open the storage manager file for an existing table, read in the data, and let the ISMColumn objects read their data.
virtual rownr_t | resync64 (rownr_t nrrow)
| Resync the storage manager with the new file contents.
virtual void | reopenRW ()
| Reopen the storage manager files for read/write.
virtual void | deleteManager ()
| The data manager will be deleted (because all its columns are requested to be deleted).
void | init ()
| Let the storage manager initialize itself.
virtual void | addRow64 (rownr_t nrrow)
| Add rows to the storage manager.
virtual void | removeRow64 (rownr_t rownr)
| Delete a row from all columns.
virtual void | addColumn (DataManagerColumn *)
| Do the final addition of a column.
virtual void | removeColumn (DataManagerColumn *)
| Remove a column from the data file and the colSet_p.
virtual DataManagerColumn * | makeScalarColumn (const String &name, int dataType, const String &dataTypeID)
| Create a column in the storage manager on behalf of a table column.
virtual DataManagerColumn * | makeDirArrColumn (const String &name, int dataType, const String &dataTypeID)
| Create a direct array column.
virtual DataManagerColumn * | makeIndArrColumn (const String &name, int dataType, const String &dataTypeID)
| Create an indirect array column.
BucketCache & | getCache ()
| Get the cache object.
ISMIndex & | getIndex ()
| Get the index object.
void | makeCache ()
| Construct the cache object (if not constructed yet).
void | makeIndex ()
| Construct the index object (if not constructed yet) and read it.
void | readIndex ()
| Read the index (at the end of the file).
void | writeIndex ()
| Write the index (at the end of the file).

## Private Attributes

String | dataManName_p
| Name of data manager.
uInt | version_p
| The version of the class.
StManArrayFile * | iosfile_p
| The file containing the indirect arrays.
uInt | uniqnr_p
| Unique nr for column in this storage manager.
rownr_t | nrrow_p
| The number of rows in the columns.
Block< ISMColumn * > | colSet_p
| The assembly of all columns.
BucketCache * | cache_p
| The cache with the ISM buckets.
BucketFile * | file_p
| The file containing all data.
ISMIndex * | index_p
| The ISM bucket index.
uInt | persCacheSize_p
| The persistent cache size.
uInt | cacheSize_p
| The actual cache size.
uInt | nbucketInit_p
| The initial number of buckets in the cache.
uInt | nFreeBucket_p
| The nr of free buckets.
Int | firstFree_p
| The first free bucket.
uInt | bucketSize_p
| The bucket size.
Bool | checkBucketSize_p
| Check a positive bucketsize?
Bool | dataChanged_p
| Has the data changed since the last flush?
uInt | uIntSize_p
| The size of a uInt in external format (local or canonical).
uInt | rownrSize_p
| The size of a rownr in external format (local or canonical).
char * | tempBuffer_p
| A temporary read/write buffer (also for other classes).

## Additional Inherited Members

Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.

## Detailed Description

Base class of the Incremental Storage Manager

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tIncrementalStMan

### Prerequisite

- IncrementalStMan
- ISMColumn

### Etymology

ISMBase is the base class of the Incremental Storage Manager.

### Synopsis

The behaviour of this class is described in IncrementalStMan.

### Motivation

The public interface of ISMBase is quite large, because the other internal ISM classes need these functions. To have a class with a minimal interface for the normal user, class IncrementalStMan is derived from it.
IncrementalStMan needs an isA- instead of hasA-relation to be able to bind columns to it in class SetupNewTable.

### To Do

- Removed AipsIO argument from open and close.

Definition at line 85 of file ISMBase.h.

## Constructor & Destructor Documentation

## ISMBase() [1/4]

casacore::ISMBase::ISMBase | ( | uInt | bucketSize = 0,
|  | Bool | checkBucketSize = True,
|  | uInt | cacheSize = 1 )

explicit

Create an incremental storage manager without a name.

The bucket size has to be given in bytes and the cache size in buckets. The bucket size is checked or calculated (if 0) as described in IncrementalStMan.h.

References bucketSize(), cacheSize(), and casacore::True.

Referenced by ISMBase(), and operator=().

## ISMBase() [2/4]

casacore::ISMBase::ISMBase | ( | const String & | dataManagerName,
|  | uInt | bucketSize,
|  | Bool | checkBucketSize,
|  | uInt | cacheSize )

Create an incremental storage manager with the given name.

The bucket size has to be given in bytes and the cache size in buckets. The bucket size is checked or calculated (if 0) as described in IncrementalStMan.h.

References bucketSize(), cacheSize(), and dataManagerName().

## ISMBase() [3/4]

casacore::ISMBase::ISMBase | ( | const String & | aDataManName,
|  | const Record & | spec )

Create an incremental storage manager with the given name.

The specifications are in the record (as created by dataManagerSpec).

References casacore::Record().

## ~ISMBase()

casacore::ISMBase::~ISMBase | ( |  | ) |

## ISMBase() [4/4]

casacore::ISMBase::ISMBase | ( | const ISMBase & | that | ) |

private

Copy constructor (only meant for clone function).

References ISMBase().

## Member Function Documentation

## addBucket()

void casacore::ISMBase::addBucket | ( | rownr_t | rownr,
|  | ISMBucket * | bucket )

Add a bucket to the storage manager (i.e.

to the cache). The pointer is taken over.

## addColumn()

virtual void casacore::ISMBase::addColumn | ( | DataManagerColumn * |  | ) |

private virtual

Do the final addition of a column.

The DataManagerColumn object has already been created (by the makeXXColumn function) and added to colSet_p. However, it still has to be added to the data files, which is done by this function. It uses the pointer to find the correct column in the colSet_p.

Reimplemented from casacore::DataManager.

## addRow64()

virtual void casacore::ISMBase::addRow64 | ( | rownr_t | nrrow | ) |

private virtual

Add rows to the storage manager.

Per column it extends the interval for which the last value written is valid.

Reimplemented from casacore::DataManager.

## bucketSize()

uInt casacore::ISMBase::bucketSize | ( |  | ) | const

inline

Get the bucket size (in bytes).

Definition at line 405 of file ISMBase.h.

References bucketSize_p.

Referenced by casacore::IncrementalStMan::IncrementalStMan(), casacore::IncrementalStMan::IncrementalStMan(), ISMBase(), and ISMBase().

## cacheSize()

uInt casacore::ISMBase::cacheSize | ( |  | ) | const

inline

Get the current cache size (in buckets).

Definition at line 390 of file ISMBase.h.

References cacheSize_p.

Referenced by casacore::IncrementalStMan::IncrementalStMan(), casacore::IncrementalStMan::IncrementalStMan(), ISMBase(), ISMBase(), and setCacheSize().

## canAddColumn()

virtual Bool casacore::ISMBase::canAddColumn | ( |  | ) | const

virtual

Can the storage manager add columns?

(not yet)

Reimplemented from casacore::DataManager.

## canAddRow()

virtual Bool casacore::ISMBase::canAddRow | ( |  | ) | const

virtual

Can the storage manager add rows?

(yes)

Reimplemented from casacore::DataManager.

## canRemoveColumn()

virtual Bool casacore::ISMBase::canRemoveColumn | ( |  | ) | const

virtual

Can the storage manager delete columns?

(not yet)

Reimplemented from casacore::DataManager.

## canRemoveRow()

virtual Bool casacore::ISMBase::canRemoveRow | ( |  | ) | const

virtual

Can the storage manager delete rows?

(yes)

Reimplemented from casacore::DataManager.

## checkBucketLayout()

Bool casacore::ISMBase::checkBucketLayout | ( | uInt & | offendingCursor,
|  | rownr_t & | offendingBucketStartRow,
|  | uInt & | offendingBucketNrow,
|  | uInt & | offendingBucketNr,
|  | uInt & | offendingCol,
|  | uInt & | ffendingIndex,
|  | rownr_t & | offendingRow,
|  | rownr_t & | offendingPrevRow )

Check that there are no repeated rowIds in the buckets comprising this ISM.

## clearCache()

void casacore::ISMBase::clearCache | ( |  | ) |

Clear the cache used by this storage manager.

It will flush the cache as needed and remove all buckets from it.

## clone()

virtual DataManager * casacore::ISMBase::clone | ( |  | ) | const

virtual

Clone this object.

It does not clone ISMColumn objects possibly used. The caller has to delete the newly created object.

Implements casacore::DataManager.

References casacore::DataManager::DataManager().

## create64()

virtual void casacore::ISMBase::create64 | ( | rownr_t | nrrow | ) |

private virtual

Let the storage manager create files as needed for a new table.

This allows a column with an indirect array to create its file.

Reimplemented from casacore::DataManager.

## dataManagerName()

virtual String casacore::ISMBase::dataManagerName | ( |  | ) | const

virtual

Get the name given to the storage manager (in the constructor).

Reimplemented from casacore::DataManager.

Referenced by casacore::IncrementalStMan::IncrementalStMan(), and ISMBase().

## dataManagerSpec()

virtual Record casacore::ISMBase::dataManagerSpec | ( |  | ) | const

virtual

Record a record containing data manager specifications.

Reimplemented from casacore::DataManager.

References casacore::Record().

## dataManagerType()

virtual String casacore::ISMBase::dataManagerType | ( |  | ) | const

virtual

Get the type name of the data manager (i.e.

IncrementalStMan).

Implements casacore::DataManager.

Referenced by makeObject().

## deleteManager()

virtual void casacore::ISMBase::deleteManager | ( |  | ) |

private virtual

The data manager will be deleted (because all its columns are requested to be deleted).

So clean up the things needed (e.g. delete files).

Implements casacore::DataManager.

## flush()

virtual Bool casacore::ISMBase::flush | ( | AipsIO & | ,
|  | Bool | fsync )

private virtual

Flush and optionally fsync the data.

It returns a True status if it had to flush (i.e. if data have changed).

Implements casacore::DataManager.

## getBucket()

ISMBucket * casacore::ISMBase::getBucket | ( | rownr_t | rownr,
|  | rownr_t & | bucketStartRow,
|  | rownr_t & | bucketNrrow )

Get the bucket containing the given row.

Also return the first and last row of that bucket. The bucket object is created and deleted by the caching mechanism.

## getCache()

BucketCache & casacore::ISMBase::getCache | ( |  | ) |

inline private

Get the cache object.

This will construct the cache object if not present yet. The cache object will be deleted by the destructor.

Definition at line 425 of file ISMBase.h.

References cache_p, and makeCache().

## getColumn()

ISMColumn & casacore::ISMBase::getColumn | ( | uInt | colnr | ) |

inline

Get access to the given column.

Definition at line 441 of file ISMBase.h.

References colSet_p.

## getIndex()

ISMIndex & casacore::ISMBase::getIndex | ( |  | ) |

inline private

Get the index object.

This will construct the index object if not present yet. The index object will be deleted by the destructor.

Definition at line 433 of file ISMBase.h.

References index_p, and makeIndex().

## getProperties()

virtual Record casacore::ISMBase::getProperties | ( |  | ) | const

virtual

Get data manager properties that can be modified.

It is only ActualCacheSize (the actual cache size in buckets). It is a subset of the data manager specification.

Reimplemented from casacore::DataManager.

References casacore::Record().

## hasMultiFileSupport()

virtual Bool casacore::ISMBase::hasMultiFileSupport | ( |  | ) | const

private virtual

The data manager supports use of MultiFile.

Reimplemented from casacore::DataManager.

## init()

void casacore::ISMBase::init | ( |  | ) |

private

Let the storage manager initialize itself.

It is used by create and open.

## makeCache()

void casacore::ISMBase::makeCache | ( |  | ) |

private

Construct the cache object (if not constructed yet).

Referenced by getCache().

## makeDirArrColumn()

virtual DataManagerColumn * casacore::ISMBase::makeDirArrColumn | ( | const String & | name,
|  | int | dataType,
|  | const String & | dataTypeID )

private virtual

Create a direct array column.

Implements casacore::DataManager.

References casacore::dataType(), and casacore::name().

## makeIndArrColumn()

virtual DataManagerColumn * casacore::ISMBase::makeIndArrColumn | ( | const String & | name,
|  | int | dataType,
|  | const String & | dataTypeID )

private virtual

Create an indirect array column.

Implements casacore::DataManager.

References casacore::dataType(), and casacore::name().

## makeIndex()

void casacore::ISMBase::makeIndex | ( |  | ) |

private

Construct the index object (if not constructed yet) and read it.

Referenced by getIndex().

## makeObject()

DataManager * casacore::ISMBase::makeObject | ( | const String & | dataManagerType,
|  | const Record & | spec )

static

Make the object from the type name string.

This function gets registered in the DataManager "constructor" map. The caller has to delete the object.

References casacore::DataManager::DataManager(), dataManagerType(), and casacore::Record().

## makeScalarColumn()

virtual DataManagerColumn * casacore::ISMBase::makeScalarColumn | ( | const String & | name,
|  | int | dataType,
|  | const String & | dataTypeID )

private virtual

Create a column in the storage manager on behalf of a table column.

The caller has to delete the newly created object.

Create a scalar column.

Implements casacore::DataManager.

References casacore::dataType(), and casacore::name().

## nextBucket()

ISMBucket * casacore::ISMBase::nextBucket | ( | uInt & | cursor,
|  | rownr_t & | bucketStartRow,
|  | rownr_t & | bucketNrrow )

Get the next bucket.

cursor=0 indicates the start of the iteration. The first bucket returned is the bucket containing the rownr given in bucketStartRow. After each iteration BucketStartRow and bucketNrrow are set. A 0 is returned when no more buckets. The bucket object is created and deleted by the caching mechanism.

## nrow()

rownr_t casacore::ISMBase::nrow | ( |  | ) | const

inline

Get the number of rows in this storage manager.

Definition at line 400 of file ISMBase.h.

References nrrow_p.

## open64()

virtual rownr_t casacore::ISMBase::open64 | ( | rownr_t | nrrow,
|  | AipsIO & | )

private virtual

Open the storage manager file for an existing table, read in the data, and let the ISMColumn objects read their data.

Reimplemented from casacore::DataManager.

## openArrayFile()

StManArrayFile * casacore::ISMBase::openArrayFile | ( | ByteIO::OpenOption | opt | ) |

Open (if needed) the file for indirect arrays with the given mode.

Return a pointer to the object.

## operator=()

ISMBase & casacore::ISMBase::operator= | ( | const ISMBase & | that | ) |

delete

Assignment cannot be used.

References ISMBase().

## readIndex()

void casacore::ISMBase::readIndex | ( |  | ) |

private

Read the index (at the end of the file).

## recreate()

void casacore::ISMBase::recreate | ( |  | ) |

private

(Re)create the index, file, and cache object.

## removeColumn()

virtual void casacore::ISMBase::removeColumn | ( | DataManagerColumn * |  | ) |

private virtual

Remove a column from the data file and the colSet_p.

The DataManagerColumn object gets deleted..

Reimplemented from casacore::DataManager.

## removeRow64()

virtual void casacore::ISMBase::removeRow64 | ( | rownr_t | rownr | ) |

private virtual

Delete a row from all columns.

Reimplemented from casacore::DataManager.

## reopenRW()

virtual void casacore::ISMBase::reopenRW | ( |  | ) |

private virtual

Reopen the storage manager files for read/write.

Reimplemented from casacore::DataManager.

## resync64()

virtual rownr_t casacore::ISMBase::resync64 | ( | rownr_t | nrrow | ) |

private virtual

Resync the storage manager with the new file contents.

This is done by clearing the cache.

Reimplemented from casacore::DataManager.

## rownrSize()

uInt casacore::ISMBase::rownrSize | ( |  | ) | const

inline

Get the size of a rownr in external format (can be canonical or local).

Definition at line 415 of file ISMBase.h.

References rownrSize_p.

## setBucketDirty()

void casacore::ISMBase::setBucketDirty | ( |  | ) |

Make the current bucket in the cache dirty (i.e.

something has been changed in it and it needs to be written when removed from the cache). (used by ISMColumn::putValue).

## setCacheSize()

void casacore::ISMBase::setCacheSize | ( | uInt | cacheSize,
|  | Bool | canExceedNrBuckets )

Set the cache size (in buckets).

If canExceedNrBuckets=True, the given cache size can be larger than the nr of buckets in the file. In this way the cache can be made large enough for a future file extnsion. Otherwise, it is limited to the actual number of buckets. This is useful if one wants the entire file to be cached.

References cacheSize().

## setProperties()

virtual void casacore::ISMBase::setProperties | ( | const Record & | spec | ) |

virtual

Modify data manager properties.

Only MaxCacheSize can be used. It is similar to function setCacheSize with canExceedNrBuckets=False.

Reimplemented from casacore::DataManager.

References casacore::Record().

## showBucketLayout()

void casacore::ISMBase::showBucketLayout | ( | ostream & | os | ) |

Show the layout of the buckets.

## showCacheStatistics()

virtual void casacore::ISMBase::showCacheStatistics | ( | ostream & | os | ) | const

virtual

Show the statistics of all caches used.

## showIndexStatistics()

void casacore::ISMBase::showIndexStatistics | ( | ostream & | os | ) |

Show the index statistics.

## tempBuffer()

char * casacore::ISMBase::tempBuffer | ( |  | ) | const

inline

Get access to the temporary buffer.

Definition at line 420 of file ISMBase.h.

References tempBuffer_p.

## uIntSize()

uInt casacore::ISMBase::uIntSize | ( |  | ) | const

inline

Get the size of a uInt in external format (can be canonical or local).

Definition at line 410 of file ISMBase.h.

References uIntSize_p.

## uniqueNr()

uInt casacore::ISMBase::uniqueNr | ( |  | ) |

inline

Get a unique column number for the column (it is only unique for this storage manager).

This is used by ISMColumnIndArr to create a unique file name.

Definition at line 395 of file ISMBase.h.

References uniqnr_p.

## version()

uInt casacore::ISMBase::version | ( |  | ) | const

inline

Get the version of the class.

Definition at line 385 of file ISMBase.h.

References version_p.

## writeIndex()

void casacore::ISMBase::writeIndex | ( |  | ) |

private

Write the index (at the end of the file).

## Member Data Documentation

## bucketSize_p

uInt casacore::ISMBase::bucketSize_p

private

The bucket size.

Definition at line 371 of file ISMBase.h.

Referenced by bucketSize().

## cache_p

BucketCache* casacore::ISMBase::cache_p

private

The cache with the ISM buckets.

Definition at line 355 of file ISMBase.h.

Referenced by getCache().

## cacheSize_p

uInt casacore::ISMBase::cacheSize_p

private

The actual cache size.

Definition at line 363 of file ISMBase.h.

Referenced by cacheSize().

## checkBucketSize_p

Bool casacore::ISMBase::checkBucketSize_p

private

Check a positive bucketsize?

Definition at line 373 of file ISMBase.h.

## colSet_p

Block<ISMColumn*> casacore::ISMBase::colSet_p

private

The assembly of all columns.

Definition at line 353 of file ISMBase.h.

Referenced by getColumn().

## dataChanged_p

Bool casacore::ISMBase::dataChanged_p

private

Has the data changed since the last flush?

Definition at line 375 of file ISMBase.h.

## dataManName_p

String casacore::ISMBase::dataManName_p

private

Name of data manager.

Definition at line 343 of file ISMBase.h.

## file_p

BucketFile* casacore::ISMBase::file_p

private

The file containing all data.

Definition at line 357 of file ISMBase.h.

## firstFree_p

Int casacore::ISMBase::firstFree_p

private

The first free bucket.

Definition at line 369 of file ISMBase.h.

## index_p

ISMIndex* casacore::ISMBase::index_p

private

The ISM bucket index.

Definition at line 359 of file ISMBase.h.

Referenced by getIndex().

## iosfile_p

StManArrayFile* casacore::ISMBase::iosfile_p

private

The file containing the indirect arrays.

Definition at line 347 of file ISMBase.h.

## nbucketInit_p

uInt casacore::ISMBase::nbucketInit_p

private

The initial number of buckets in the cache.

Definition at line 365 of file ISMBase.h.

## nFreeBucket_p

uInt casacore::ISMBase::nFreeBucket_p

private

The nr of free buckets.

Definition at line 367 of file ISMBase.h.

## nrrow_p

rownr_t casacore::ISMBase::nrrow_p

private

The number of rows in the columns.

Definition at line 351 of file ISMBase.h.

Referenced by nrow().

## persCacheSize_p

uInt casacore::ISMBase::persCacheSize_p

private

The persistent cache size.

Definition at line 361 of file ISMBase.h.

## rownrSize_p

uInt casacore::ISMBase::rownrSize_p

private

The size of a rownr in external format (local or canonical).

Definition at line 379 of file ISMBase.h.

Referenced by rownrSize().

## tempBuffer_p

char* casacore::ISMBase::tempBuffer_p

private

A temporary read/write buffer (also for other classes).

Definition at line 381 of file ISMBase.h.

Referenced by tempBuffer().

## uIntSize_p

uInt casacore::ISMBase::uIntSize_p

private

The size of a uInt in external format (local or canonical).

Definition at line 377 of file ISMBase.h.

Referenced by uIntSize().

## uniqnr_p

uInt casacore::ISMBase::uniqnr_p

private

Unique nr for column in this storage manager.

Definition at line 349 of file ISMBase.h.

Referenced by uniqueNr().

## version_p

uInt casacore::ISMBase::version_p

private

The version of the class.

Definition at line 345 of file ISMBase.h.

Referenced by version().

The documentation for this class was generated from the following file:

- tables/DataMan/ISMBase.h